import java.util.Vector;

abstract class Command
{
    String name, help;
    
    Command (String n, String h)
    {
        name = n;
        help = h;
    }

    String help ()
    {
        return help;
    }

    static String [] parseCommand (String command)
    {
        Vector args = new Vector ();
        StringBuffer arg = new StringBuffer ();
        boolean escaped = false,
                quoted = false;
        for (int i = 1; i < command.length (); ++ i)
        {
            char c = command.charAt (i);
            if (escaped)
            {
                arg.append (c);
                escaped = false;
            }
            else
            if (c == '\\')
                escaped = true;
            else
            if (c == '"')
            {
                if (quoted || arg.length () > 0)
                {
                    args.addElement (arg.toString ());
                    arg.delete (0, arg.length ());
                }
                quoted = ! quoted;
            }
            else
            if (c == ' ')
            {
                if (quoted)
                    arg.append (c);
                else
                if (arg.length () > 0)
                {
                    args.addElement (arg.toString ());
                    arg.delete (0, arg.length ());
                }
            }
            else
                arg.append (c);
        }                
        if (arg.length () > 0)
        {
            args.addElement (arg.toString ());
            arg.delete (0, arg.length ());
        }
        String [] result = new String [args.size ()];
        args.copyInto (result);
        return result;
    }

    abstract boolean execute (Terminal terminal, String [] args);
}

