import java.awt.Graphics;

abstract class Fragment extends Link
{
    Action action;
    int column;
   
    Fragment (Action a, int c)
    {
        action = a;
        column = c;
    }

    int endColumn ()
    {
        return column + width ();
    }

    void activate (Terminal terminal)
    {
        if (action != null)
            action.doIt (terminal);
    }

    boolean maySelect ()
    {
        return false;
    }

    boolean merge (Fragment fragment)
    {
        return false;
    }

    void select (StringBuffer buffer, int offset, int length)
    {
    }

    abstract int width ();
    abstract void draw (Graphics g, Terminal terminal, int row);
}
