import java.util.Iterator;

class HelpCommand extends Command
{
    HelpCommand ()
    {
        super ("help", "\034F15\035/help [command]\034C\035\n\nShow usage information about a command.\nHelp exists for the following commands:\n");
    }

    boolean execute (Terminal terminal, String [] args)
    {
        String command = (args.length >= 2 ? args [1] : "help");
        if (! terminal.commands.containsKey (command))
        {
            terminal.addText ("There is no command \"\034F9\035" + command + "\034C\035\". See \"\034H/help\035\034F6\035/help\034C\035\" for available commands.\n");
            return true;
        }
        terminal.addText ("\n" + ((Command) terminal.commands.get (command)).help ());
        if (command.equals ("help"))
        {
            Iterator i = terminal.commands.keySet ().iterator ();
            boolean separate = false;
            while (i.hasNext ())
            {
                String name = (String) i.next ();
                if (separate)
                    terminal.addText (i.hasNext () ? ", " : ", and ");
                terminal.addText ("\034H/help " + name + "\035\034F6\035" + name + "\034C\035");
                separate = true;
            }
            terminal.addText (".\n");
        } 
        return true;
    }    
}

