import java.awt.Color;
import java.awt.Graphics;

class TextFragment extends Fragment
{
    Color foregroundColor, backgroundColor;
    String text;

    TextFragment (Action a, int c, Color f, Color b, String t)
    {
        super (a, c);
        foregroundColor = f;
        backgroundColor = b;
        text = t;
    }

    boolean maySelect ()
    {
        return true;
    }
    
    void select (StringBuffer buffer, int offset, int length)
    {
        while (offset < length)
            buffer.append (text.charAt (offset ++));
    }

    int width ()
    {
        return text.length ();
    }

    boolean merge (Fragment fragment)
    {
        if (fragment instanceof TextFragment)
        {
            TextFragment textFragment = (TextFragment) fragment;
            if (action == textFragment.action && 
                foregroundColor == textFragment.foregroundColor &&
                backgroundColor == textFragment.backgroundColor &&
                endColumn () == textFragment.column)
            {
                append (textFragment.text);
                return true;
            }
        }
        return false;
    }

    void draw (Graphics g, Terminal terminal, int row)
    {
        int tx = column * terminal.cellWidth + terminal.BORDER,
            ty = (row + 1) * terminal.cellHeight + terminal.BORDER;

        g.setColor (backgroundColor);
        g.fillRect (tx, ty - terminal.cellHeight, tx + text.length () * terminal.cellWidth, ty);

        g.setColor (foregroundColor);
        g.drawString (text, tx, ty - terminal.cellOffset - 1);

        if (action != null)
            g.drawLine (tx, ty - 1, tx + text.length () * terminal.cellWidth, ty - 1);
    }

    void append (String s)
    {
        text = text.concat (s);
    }

    void append (char [] c)
    {
        text = text.concat (new String (c));
    }

    void append (char c)
    {
        char d [] = { c };
        append (d);
    }
}

